#include <bluefruit.h>

bool cbFlag = false;
uint8_t advBuffer[32];
uint8_t rspBuffer[32];
uint8_t advPrintBuffer[32];
uint8_t rspPrintBuffer[32];
uint8_t advLen;
uint8_t rspLen;
int rss;

void setup() 
{
  Serial.begin(115200);
  while (!Serial);

  Bluefruit.begin(0, 1);
  Bluefruit.setTxPower(4);

  /* Set the device name */
  Bluefruit.setName("Bluefruit52");

  /* Set the LED interval for blinky pattern on BLUE LED */
  Bluefruit.setConnLedInterval(250);

  /* Start Central Scanning */
  Bluefruit.Scanner.setRxCallback(scan_callback);
  Bluefruit.Scanner.restartOnDisconnect(true);
  Bluefruit.Scanner.filterMSD(0xFFFF);          // 0xFFFF for Experiment, 0x0059 for Nordic semi
  Bluefruit.Scanner.setIntervalMS(100,100);
  Bluefruit.Scanner.useActiveScan(true);        // Request scan response data
  Bluefruit.Scanner.start(0);                   // 0 = Don't stop scanning after n seconds

  Serial.println("Scanning ...");
}

void scan_callback(ble_gap_evt_adv_report_t* report)
{
  cbFlag = true;

  if (report->type.scan_response)
  {
    rspLen = Bluefruit.Scanner.parseReportByType(report, BLE_GAP_AD_TYPE_MANUFACTURER_SPECIFIC_DATA, rspBuffer, sizeof(rspBuffer)); 
    memcpy(rspPrintBuffer, rspBuffer, rspLen);
    memset(rspBuffer, 0, rspLen);
  }
  else
  {
    advLen = Bluefruit.Scanner.parseReportByType(report, BLE_GAP_AD_TYPE_MANUFACTURER_SPECIFIC_DATA, advBuffer, sizeof(advBuffer));
    memcpy(advPrintBuffer, advBuffer, advLen);
    memset(advBuffer, 0, advLen);
  }
  
  rss = report->rssi;  
  Bluefruit.Scanner.resume();
}

void loop() 
{
  if(cbFlag)
  {        
    cbFlag = false;
    Serial.print("++++++++ ADV "); Serial.print(advLen);
    Serial.print("    RSSI "); Serial.println(rss);
    for(int i = 0; i < advLen; i++)
    {
      if(advPrintBuffer[i] < 16) { Serial.print(0); }
      Serial.print(advPrintBuffer[i], HEX); Serial.print(" ");       
    }
    Serial.println();
 
    Serial.print("-------- RSP "); Serial.println(rspLen);
    for(int i = 0; i < rspLen; i++)
    {
      if(rspPrintBuffer[i] < 16) { Serial.print(0); }
      Serial.print(rspPrintBuffer[i], HEX); Serial.print(" ");       
    }
    Serial.println();
    
    Serial.println("========"); Serial.println();
  }
}
